jQuery(document).on('pageshow', '#idMenu', function() {
	{
		jQuery('#idMenu_SelectAccount_Accounts')
			.off('update')
			.on('update', function() {
				jQuery(this)
					.empty()
				;
				
				{
					jsPreferenceAccount.selectAcquire();
					
					jsPreferenceAccount.selectOpen(
						'SELECT * ' +
						'FROM   PreferenceAccount ' + 
						'ORDER  BY strWebsite ASC ',
						[]
					);
					
					do {
						jsPreferenceAccount.selectNext();
						
						var intIdent = jsPreferenceAccount.getIntIdent();
						var strWebsite = String(jsPreferenceAccount.getStrWebsite());
						var strMail = String(jsPreferenceAccount.getStrMail());
						var strUser = String(jsPreferenceAccount.getStrUser());
						
						if (intIdent === 0) {
							break;
						}
						
						var strExtension = '';
						
						{
							if (strMail === '') {
								strExtension = strUser;
								
							} else if (strUser === '') {
								strExtension = strMail;
								
							}
							
							if (strMail !== '') {
								if (strUser !== '') {
									strExtension = strMail + ' - ' + strUser;
								}
							}
						}
						
						jQuery(this)
							.append(jQuery('<li></li>')
								.data({
									'intIdent': intIdent,
									'strWebsite': strWebsite,
									'strMail': strMail,
									'strUser': strUser
								})
								.append(jQuery('<a></a>')
									.attr({
										'href': '#'
									})
									.off('click')
									.on('click', function() {
										{
											AccountRect.Menu_SelectedAccount_intIdent = jQuery(this).parents('li').eq(0).data('intIdent');
											AccountRect.Menu_SelectedAccount_strWebsite = jQuery(this).parents('li').eq(0).data('strWebsite');
											AccountRect.Menu_SelectedAccount_strMail = jQuery(this).parents('li').eq(0).data('strMail');
											AccountRect.Menu_SelectedAccount_strUser = jQuery(this).parents('li').eq(0).data('strUser');
										}
										
										{
											jQuery('#idMain_SelectedAccount_Website')
												.trigger('update')
											;
											
											jQuery('#idMain_SelectedAccount_Mail')
												.trigger('update')
											;
											
											jQuery('#idMain_SelectedAccount_User')
												.trigger('update')
											;
											
											jQuery('#idMain_GeneratedPassword_Password')
												.trigger('update')
											;
										}
									})
									.append(jQuery('<h3></h3>')
										.text(strWebsite)
									)
									.append(jQuery('<p></p>')
										.text(strExtension)
									)
								)
								.append(jQuery('<a></a>')
									.attr({
										'data-rel': 'popup',
										'href': '#idMenu_SelectAccount_Account'
									})
									.off('click')
									.on('click', function() {
										{
											AccountRect.Menu_SelectAccount_intIdent = jQuery(this).parents('li').eq(0).data('intIdent');
											AccountRect.Menu_SelectAccount_strWebsite = jQuery(this).parents('li').eq(0).data('strWebsite');
											AccountRect.Menu_SelectAccount_strMail = jQuery(this).parents('li').eq(0).data('strMail');
											AccountRect.Menu_SelectAccount_strUser = jQuery(this).parents('li').eq(0).data('strUser');
										}
										
										{
											jQuery('#idMenu_SelectAccount_Account_User')
												.trigger('update')
											;
										}
									})
								)
							)
						;
					} while (true);
					
					jsPreferenceAccount.selectClose();
					
					jsPreferenceAccount.selectRelease();
				}
				
				jQuery(this)
					.listview('refresh')
				;
			})
		;
		
		jQuery('#idMenu_SelectAccount_Accounts')
			.trigger('update')
		;
	}
	
	{
		{
			jQuery('#idMenu_CreateAccount_Website')
				.off('input')
				.on('input', function() {
					jQuery('#idMenu_CreateAccount_Create')
						.trigger('update')
					;
				})
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val('')
					;
				})
			;
			
			jQuery('#idMenu_CreateAccount_Website')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMenu_CreateAccount_Mail')
				.off('input')
				.on('input', function() {
					jQuery('#idMenu_CreateAccount_Create')
						.trigger('update')
					;
				})
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val('')
					;
				})
			;
			
			jQuery('#idMenu_CreateAccount_Mail')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMenu_CreateAccount_User')
				.off('input')
				.on('input', function() {
					jQuery('#idMenu_CreateAccount_Create')
						.trigger('update')
					;
				})
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val('')
					;
				})
			;
			
			jQuery('#idMenu_CreateAccount_User')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMenu_CreateAccount_Create')
				.off('click')
				.on('click', function() {
					var strWebsite = jQuery('#idMenu_CreateAccount_Website').val();
					var strMail = jQuery('#idMenu_CreateAccount_Mail').val();
					var strUser = jQuery('#idMenu_CreateAccount_User').val();
					
					{
						jsPreferenceAccount.setStrWebsite(strWebsite);
						jsPreferenceAccount.setStrMail(strMail);
						jsPreferenceAccount.setStrUser(strUser);
						
						jsPreferenceAccount.create();
					}
					
					{
						jQuery('#idMenu_SelectAccount_Accounts')
							.trigger('update')
						;
					}
					
					{
						jQuery('#idMenu_CreateAccount_Website')
							.trigger('update')
						;
					
						jQuery('#idMenu_CreateAccount_Mail')
							.trigger('update')
						;
					
						jQuery('#idMenu_CreateAccount_User')
							.trigger('update')
						;
						
						jQuery('#idMenu_CreateAccount_Create')
							.trigger('update')
						;
					}
				})
				.off('update')
				.on('update', function() {
					var strWebsite = jQuery('#idMenu_CreateAccount_Website').val();
					var strMail = jQuery('#idMenu_CreateAccount_Mail').val();
					var strUser = jQuery('#idMenu_CreateAccount_User').val();
					
					if (strWebsite === '') {
						jQuery(this)
							.addClass('ui-disabled')
						;
						
					} else if (strMail === '') {
						jQuery(this)
							.addClass('ui-disabled')
						;
						
					}
					
					if (strWebsite !== '') {
						if (strMail !== '') {
							jQuery(this)
								.removeClass('ui-disabled')
							;
						}
					}
				})
			;
			
			jQuery('#idMenu_CreateAccount_Create')
				.trigger('update')
			;
		}
	}
	
	{
		{
			jQuery('#idMain_SelectedAccount_Website')
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val(AccountRect.Menu_SelectedAccount_strWebsite)
					;
				})
			;
			
			jQuery('#idMain_SelectedAccount_Website')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMain_SelectedAccount_Mail')
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val(AccountRect.Menu_SelectedAccount_strMail)
					;
				})
			;
			
			jQuery('#idMain_SelectedAccount_Mail')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMain_SelectedAccount_User')
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val(AccountRect.Menu_SelectedAccount_strUser)
					;
				})
			;
			
			jQuery('#idMain_SelectedAccount_User')
				.trigger('update')
			;
		}
	}
	
	{
		jQuery('#idMain_Masterpassword_Password')
			.off('input')
			.on('input', function() {
				jQuery('#idMain_GeneratedPassword_Password')
					.trigger('update')
				;
			})
		;
	}
	
	{
		{
			jQuery('#idMain_GeneratedPassword_Password')
				.off('update')
				.on('update', function() {
					var strMasterpassword = jQuery('#idMain_Masterpassword_Password').val();
					var strWebsite = AccountRect.Menu_SelectedAccount_strWebsite;
					var strMail = AccountRect.Menu_SelectedAccount_strMail;
					
					var strSpecial = '';
					
					{
						if (jQuery('#idMenu_GeneratedPassword_Exclamation').is(':checked') === true) {
							strSpecial += '!';
						}
						
						if (jQuery('#idMenu_GeneratedPassword_Question').is(':checked') === true) {
							strSpecial += '?';
						}
						
						if (jQuery('#idMenu_GeneratedPassword_At').is(':checked') === true) {
							strSpecial += '@';
						}
						
						if (jQuery('#idMenu_GeneratedPassword_Sharp').is(':checked') === true) {
							strSpecial += '#';
						}
					}
					
					var intLength = parseInt(jQuery('#idMain_GeneratedPassword_Length').val(), 10);
					
					jQuery('#idMain_GeneratedPassword_Password')
						.val(jsPassword.get(strMasterpassword, strWebsite, strMail, strSpecial, intLength))
					;
				})
			;
			
			jQuery('#idMain_GeneratedPassword_Password')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMenu_GeneratedPassword_Exclamation')
				.off('change')
				.on('change', function() {
					jQuery('#idMain_GeneratedPassword_Password')
						.trigger('update')
					;
				})
			;
			
			jQuery('#idMenu_GeneratedPassword_Question')
				.off('change')
				.on('change', function() {
					jQuery('#idMain_GeneratedPassword_Password')
						.trigger('update')
					;
				})
			;
			
			jQuery('#idMenu_GeneratedPassword_At')
				.off('change')
				.on('change', function() {
					jQuery('#idMain_GeneratedPassword_Password')
						.trigger('update')
					;
				})
			;
			
			jQuery('#idMenu_GeneratedPassword_Sharp')
				.off('change')
				.on('change', function() {
					jQuery('#idMain_GeneratedPassword_Password')
						.trigger('update')
					;
				})
			;
		}
		
		{
			jQuery('#idMain_GeneratedPassword_Length')
				.off('input')
				.on('input', function() {
					jQuery('#idMain_GeneratedPassword_Password')
						.trigger('update')
					;
				})
			;
		}
	}
	
	{
		{
			jQuery('#idMenu_SelectAccount_Account_User')
				.off('input')
				.on('input', function() {
					var strUser = jQuery('#idMenu_SelectAccount_Account_User').val();
					
					AccountRect.Menu_SelectAccount_strUser = strUser;
				})
				.off('update')
				.on('update', function() {
					jQuery(this)
						.css({
							'padding-left': (jQuery(this).parent().prev().width() + 15) + 'px'
						})
						.val(AccountRect.Menu_SelectAccount_strUser)
					;
				})
			;
			
			jQuery('#idMenu_SelectAccount_Account_User')
				.trigger('update')
			;
		}
		
		{
			jQuery('#idMenu_SelectAccount_Account_Save')
				.off('click')
				.on('click', function() {
					jQuery('#idMenu_SelectAccount_Account')
						.popup('close')
					;
					
					{
						jsPreferenceAccount.setIntIdent(AccountRect.Menu_SelectAccount_intIdent);
						jsPreferenceAccount.setStrWebsite(AccountRect.Menu_SelectAccount_strWebsite);
						jsPreferenceAccount.setStrMail(AccountRect.Menu_SelectAccount_strMail);
						jsPreferenceAccount.setStrUser(AccountRect.Menu_SelectAccount_strUser);
						
						jsPreferenceAccount.save();
					}
					
					{
						jQuery('#idMenu_SelectAccount_Accounts')
							.trigger('update')
						;
					}
				})
			;
		}
		
		{
			jQuery('#idMenu_SelectAccount_Account_Delete')
				.off('click')
				.on('click', function() {
					jQuery('#idMenu_SelectAccount_Account')
						.popup('close')
					;
					
					{
						jsPreferenceAccount.setIntIdent(AccountRect.Menu_SelectAccount_intIdent);
						jsPreferenceAccount.setStrWebsite(AccountRect.Menu_SelectAccount_strWebsite);
						jsPreferenceAccount.setStrMail(AccountRect.Menu_SelectAccount_strMail);
						jsPreferenceAccount.setStrUser(AccountRect.Menu_SelectAccount_strUser);
						
						jsPreferenceAccount.remove();
					}
					
					{
						jQuery('#idMenu_SelectAccount_Accounts')
							.trigger('update')
						;
					}
				})
			;
		}
	}
});

var AccountRect = {
    Menu_SelectAccount_intIdent: 0,
	Menu_SelectAccount_strWebsite: '',
	Menu_SelectAccount_strMail: '',
	Menu_SelectAccount_strUser: '',
	
    Menu_SelectedAccount_intIdent: 0,
	Menu_SelectedAccount_strWebsite: '',
	Menu_SelectedAccount_strMail: '',
	Menu_SelectedAccount_strUser: ''
};